//---------------------------------------------------------------------------
//
//	KPED	Flip Plugin
//
//			(C)2000
//			Yuuichiro Konno
//
//---------------------------------------------------------------------------
#include <windows.h>
#include "../kplgtlbase.h"
#include "resource.h"
#include "stdio.h"
#pragma hdrstop

LRESULT CALLBACK ToolDLG(HWND hdlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	KPTarg *arg;
	//bZ[Wɏ]
	switch(uMsg){
	case WM_INITDIALOG:
		//Ə|C^̕ۑ
		SetWindowLong(hdlg,GWL_USERDATA,(LONG)lParam);
		if((arg = (KPTarg *)GetWindowLong(hdlg,GWL_USERDATA)) == NULL)
			return(FALSE);
		//ACR\
		SendMessage(GetDlgItem(hdlg, IDC_H), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_H)));
		SendMessage(GetDlgItem(hdlg, IDC_V), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_V)));
		SendMessage(GetDlgItem(hdlg, IDC_U), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_U)));
		SendMessage(GetDlgItem(hdlg, IDC_D), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_D)));
		SendMessage(GetDlgItem(hdlg, IDC_L), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_L)));
		SendMessage(GetDlgItem(hdlg, IDC_R), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_R)));
		SendMessage(GetDlgItem(hdlg, IDC_RL), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_RL)));
		SendMessage(GetDlgItem(hdlg, IDC_RR), BM_SETIMAGE, IMAGE_ICON,
			(LPARAM)LoadIcon(arg->ext->Inst, MAKEINTRESOURCE(IDI_ICON_RR)));
		break;
	case WM_COMMAND:
		int x, y, w, h, aw, ah, lx, ly, rm;
		unsigned char *dst, *src;
		void *cur;
		RECT r;

		//Ə|C^Qbg
		if((arg = (KPTarg *)GetWindowLong(hdlg,GWL_USERDATA)) == NULL)
			return(FALSE);

		//Jg摜̃Qbg
		cur = arg->ext->getcur(arg->ext->Own);
		if(cur != NULL) arg->ext->Own = cur;
		//Jg̃Qbg
		arg->ext->getnew(arg->ext->Own, arg->dat);

		//]Ɩ
		aw = arg->dat->W;
		ah = arg->dat->H;
		if (arg->dat->Area.top == arg->dat->Area.bottom){
			x = 0; y = 0;
			w = aw; h = ah;
		}else{
			x = arg->dat->Area.left;
			y = arg->dat->Area.top;
			w = arg->dat->Area.right;
			h = arg->dat->Area.bottom;
		}
		//ƃ
		dst = arg->dat->Data;
		src = (unsigned char *)malloc(aw*ah);
		memcpy(src, dst, aw*ah);

		//bZ[Wɂs
		switch(LOWORD(wParam)){
		//E]
		case IDC_H:
			for(ly = y;ly < h;ly++)
			for(lx = x;lx < w;lx++)
				dst[ly*aw+lx] = src[ly*aw+(w-(lx-x)-1)];
			break;
		//㉺]
		case IDC_V:
			for(ly = y;ly < h;ly++)
			for(lx = x;lx < w;lx++)
				dst[ly*aw+lx] = src[(h-(ly-y)-1)*aw+lx];
			break;
		//Eړ
		case IDC_R:
			for(ly = y;ly < h;ly++)
			{
				dst[ly*aw+x] = src[ly*aw+(w-1)];
				for(lx = x+1;lx < w;lx++)
					dst[ly*aw+lx] = src[ly*aw+lx-1];
			}
			break;
		//ړ
		case IDC_L:
			for(ly = y;ly < h;ly++)
			{
				for(lx = x;lx < w-1;lx++)
					dst[ly*aw+lx] = src[ly*aw+lx+1];
				dst[ly*aw+w-1] = src[ly*aw+x];
			}
			break;
		//ړ
		case IDC_U:
			for(lx = x;lx < w;lx++)
			{
				dst[(h-1)*aw+lx] = src[y*aw+lx];
				for(ly = y;ly < h-1;ly++)
					dst[ly*aw+lx] = src[(ly+1)*aw+lx];
			}
			break;
		//ړ
		case IDC_D:
			for(lx = x;lx < w;lx++)
			{
				for(ly = y+1;ly < h;ly++)
					dst[ly*aw+lx] = src[(ly-1)*aw+lx];
				dst[y*aw+lx] = src[(h-1)*aw+lx];
			}
			break;
		//E]
		case IDC_RR:
			rm = (w-x)<(h-y)?(w-x):(h-y);
			for(ly = 0;ly < rm;ly++)
			for(lx = 0;lx < rm;lx++)
				dst[(y+ly)*aw+(x+lx)] = src[(y+rm-lx)*aw+(x+ly)];
			break;
		//]
		case IDC_RL:
			rm = (w-x)<(h-y)?(w-x):(h-y);
			for(ly = 0;ly < rm;ly++)
			for(lx = 0;lx < rm;lx++)
				dst[(y+ly)*aw+(x+lx)] = src[(y+lx)*aw+(x+rm-ly)];
			break;
		}

		//ƃJčĕ`
		free(src);
		r.left = x;r.right = w+1;
		r.top = y;r.bottom = h+1;
		arg->ext->redraw(arg->ext->Own, &r);
		break;
	case WM_CLOSE:
		EndDialog(hdlg,IDOK);
		break;
	default:
		return(FALSE);
	}
	return(TRUE);

}


//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}
//---------------------------------------------------------------------------
void Info(char *kind, void **user)
{
	wsprintf(kind, "]c[");
}
//---------------------------------------------------------------------------
void Down(KPTarg *arg)
{
}
//---------------------------------------------------------------------------
void Drag(KPTarg *arg)
{
}
//---------------------------------------------------------------------------
void Up(KPTarg *arg)
{
}
//---------------------------------------------------------------------------
void Dialog(KPTarg *arg, void **user)
{
	CreateDialogParam(arg->ext->Inst, MAKEINTRESOURCE(IDD_UPDOWN), arg->ext->Wnd, (DLGPROC)ToolDLG,(LPARAM)arg);
}

//---------------------------------------------------------------------------


